using System;
using System.Windows.Forms;
using System.Net;

namespace MorrowindModManager {
    public partial class About : Form {
        public About() {
            InitializeComponent();
            label1.Text="morrowind mod manager v"+Program.version;
        }

        private void bVisit_Click(object sender, EventArgs e) {
            System.Diagnostics.Process.Start("http://timeslip.chorrol.com");
        }

        private void bUpdate_Click_Old(object sender, EventArgs e) {
            try {
                WebRequest wr=WebRequest.Create("http://timeslip.chorrol.com/update/mwmmversion");
                WebResponse response=wr.GetResponse();
                if(response.ContentLength!=4) throw new mwmmException("The update file contained invalid data");

                System.IO.Stream s=response.GetResponseStream();
                byte[] b = new byte[4];
                s.Read(b, 0, 4);
                if(b[0]>Program.MajorVersion||
                    (b[0]==Program.MajorVersion&&b[1]>Program.MinorVersion)||
                    (b[0]==Program.MajorVersion&&b[1]==Program.MinorVersion&&b[2]>Program.BuildNumber)) {
                    MessageBox.Show("A new version, '"+b[0]+"."+b[1]+"."+b[2]+"' is available", "Message");
                } else {
                    MessageBox.Show("No new version is available at this time.", "Message");
                }
            } catch (Exception ex) {
                MessageBox.Show("An error occured checking the latest version\n"+
                    "Error: "+ex.Message, "Error");
            }
        }
    }
}