using System;
using System.Windows.Forms;

namespace MorrowindModManager.Forms {
    public partial class SelectForm : Form {
        public SelectForm(string[] items,string title,bool Multi,string[] previews) {
            InitializeComponent();
            Text=title;
            lbSelect.Items.AddRange(items);
            if(Multi) {
                lbSelect.SelectionMode=SelectionMode.MultiSimple;
                label1.Text="Select any number of options";
            } else {
                lbSelect.SelectedIndex=0;
            }
            if(previews!=null) {
                Previews=new System.Drawing.Image[previews.Length];
                for(int i=0;i<previews.Length;i++) {
                    if(previews[i]==null) Previews[i]=null;
                    else Previews[i]=System.Drawing.Image.FromFile(previews[i]);
                }
            }
        }

        private bool blockClose=true;
        public int[] SelectedIndex={ 0 };
        private System.Drawing.Image[] Previews=null;

        private void bOK_Click(object sender, EventArgs e) {
            blockClose=false;
            SelectedIndex=new int[lbSelect.SelectedIndices.Count];
            for(int i=0;i<SelectedIndex.Length;i++) SelectedIndex[i]=lbSelect.SelectedIndices[i];
            if(Previews!=null) {
                foreach(System.Drawing.Image i in Previews) i.Dispose();
            }
            Close();
        }

        private void SelectForm_FormClosing(object sender, FormClosingEventArgs e) {
            e.Cancel=blockClose;
        }

        private void lbSelect_SelectedIndexChanged(object sender, EventArgs e) {
            if(Previews==null) return;
            if(lbSelect.SelectedIndices.Count!=1||Previews[lbSelect.SelectedIndex]==null) {
                bPreview.Enabled=false;
            } else {
                bPreview.Enabled=true;
            }
        }

        private void bPreview_Click(object sender, EventArgs e) {
            (new ImageForm(Previews[lbSelect.SelectedIndex])).ShowDialog();
        }
    }
}